<template>
  <v-card id="shoppingList" v-if="shoppingList">
    <v-card-title class="justify-space-between">
      <h3>Liste de course</h3>
      <div>
        <v-btn pull-right small color="secondary" class="v-btn--example mr-2" @click="printList" v-if="!isEmptyList">
          <v-icon>mdi-printer</v-icon>
        </v-btn>
        <v-btn pull-right small dark class="v-btn--example" @click="deleteList" v-if="!isEmptyList">
          <v-icon>mdi-delete</v-icon>
        </v-btn>
      </div>
    </v-card-title>
    <v-card-text>
      <RecipeIngredientsList v-if="!isEmptyList" :ingredients="shoppingList.RecipeIngredients" />
      <v-banner sticky v-else>Vous n'avez pas encore d'ingrédients dans votre liste de courses. Vous pouvez en ajouter en parcourant des recettes.</v-banner>
    </v-card-text>
  </v-card>
</template>

<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import { Prop } from "vue-property-decorator";
import ShoppingListService from "../../../services/ShoppingListService";
import RecipeIngredientsList from "../../recipe/components/RecipeIngredientsList.vue";
import ShoppingList from "../../../transport/ShoppingList";

@Component({
  components: {
    RecipeIngredientsList,
  },
})
export default class ShoppingListDisplay extends Vue {
  @Prop({ type: String, required: true })
  userId;
  private shoppingListService: ShoppingListService = null;
  private shoppingList: ShoppingList = null;

  get isEmptyList() {
    return this.shoppingList
      ? this.shoppingList.RecipeIngredients.length === 0
      : false;
  }
  mounted() {
    this.shoppingListService = new ShoppingListService();

    this.shoppingListService.getShoppingListFromUser(this.userId).then(res => {
      this.shoppingList = res;
    });
  }
  deleteList() {
    this.shoppingListService
      .emptyUserList(this.userId)
      .then(() => (this.shoppingList = null));
  }

  printList() {
    this.$htmlToPaper("shoppingList");
  }
}
</script>